#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <functional>

using namespace std;
typedef long long ll;

int high(int p, int k, int size) {
	int ans = 0;
	if (size - p >= k) ans++;
	if (k-1 == p) {
		ans += k-1;
	}
	return ans;
}
map<int,int> podingFill(int p,vector<int> a) {
	map<int, int> ans;
	for (int i = 0; i < a.size(); i++) {
		int l = i - 1, r = i + 1;
		int it = 2;

		while (true) {
			if (l != -1 && r != a.size() && a[l] < a[r]) {
				if (a[l] == p)break;
				l--; it++;
			}
			else if (l != -1 && r != a.size() && a[l] > a[r]) {
				if (a[l] == p)break;
				r++; it++;
			}
			else if (l != -1) {
				if (a[l] == p)break;
				l--; it++;
			}
			else if (r != a.size()) {
				if (a[l] == p)break;
				r++; it++;
			}
		}
		ans[it] = ans[it] + 1;
	}
	return ans;
}
vector<int> kodingFill(int k, vector<int> a) {
	vector<int> ans(a.size()+1);
	for (int i = 0; i < a.size(); i++) {
		if (k == 1) {
			ans[i]++;
			continue;
		}
		int l = i - 1, r = i + 1;
		int it = 2;
		int last;

		while (it-1!=k) {
			if (l != -1 && r != a.size() && a[l] < a[r]) {
				last = l;
				l--; it++;
				
			}
			else if (l != -1 && r != a.size() && a[l] > a[r]) {
				last = r;
				r++; it++;
			}
			else if (l != -1) {
				last = l;
				l--; it++;
			}
			else if (r != a.size()) {
				last = r;
				r++; it++;
			}
		}
		if(k!=1)
		ans[last]++;
		else ans[i]++;
	}
	return ans;
}
map<int, map<int,int>> def(vector<int> a) {
	map<int, map<int,int>> ans;
	for (int i = 0; i < a.size(); i++) {
		ans[i][1] = 1;
		int l = i - 1, r = i + 1; int it = 2;
		while (r!=a.size() || l!=-1) {
			if (l != -1 && r != a.size() && a[l] < a[r]) {
				ans[l][it]++;
				l--; it++;

			}
			else if (l != -1 && r != a.size() && a[l] > a[r]) {
				ans[r][it]++;
				r++; it++;
			}
			else if (l != -1) {
				ans[l][it]++;
				l--; it++;
			}
			else if (r != a.size()) {
				ans[r][it]=ans[r][it]+1;
				r++; it++;
			}
		}
	}
	return ans;
}



int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif
	bool isGettingHigh = true, doWithMap = false, kodin = true, podin = true;
	int n, q; cin >> n >> q;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (i != 0 && a[i] <= a[i - 1])isGettingHigh = false;
	}
	vector<pair<int, int>> tests;
	for (int i = 0; i < q; i++) {
		int p, k; cin >> p >> k;
		tests.emplace_back(--p, k);
		if (i != 0 && tests[i].first != tests[i - 1].first)podin = false;
		if (i != 0 && tests[i].second != tests[i - 1].second) kodin = false;
	}
	vector<int> ans;
	if (isGettingHigh) {
		for (int i = 0; i < tests.size(); i++) 
			ans.push_back(high(tests[i].first, tests[i].second,a.size()));
	}
	else if (podin) {
		map<int, int> pdmp;
		pdmp = podingFill(tests[0].first, a);
		for (int i = 0; i < tests.size(); i++) {
			ans.push_back(pdmp[tests[i].second]);
		}
	}
	else if (kodin) {
		vector<int> kdn;
		kdn = kodingFill(tests[0].second, a);
		for (int i = 0; i < tests.size(); i++) {
			ans.push_back(kdn[tests[i].second]);
		}
	}
	else {
		map<int, map<int,int>> mp; mp = def(a);
		for (int i = 0; i < tests.size(); i++) {
			ans.push_back(mp[tests[i].first][tests[i].second]);
		}
	}
	for (auto i : ans) {
		cout << i << '\n';
	}
}